hdu 4570 Multi-bit Trie(dp水题)

Multi-bit Trie

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 243    Accepted Submission(s): 84


Problem Description
  IP lookup is one of the key functions of routers for packets forwarding and classifying. Generally, IP lookup can be simplified as a Longest Prefix Matching (LPM) problem. That's to find the longest prefix in the Forwarding Information Base (FIB) that matches the input packet's destination address, and then output the corresponding Next Hop information.

  Trie-based solution is the most wildly used one to solve LPM. As shown in Fig.1(b), an uni-bit trie is just a binary tree. Processing LPM on it needs only traversing it from the root to some leaf, according to the input packet's destination address. The longest prefix along this traversing path is the matched one. In order to reduce the memory accesses for one lookup, we can compress some consecutively levels of the Uni-bit Trie into one level, transforming the Uni-bit Trie into a Multi-bit Trie.
  For example, suppose the strides array is {3, 2, 1, 1}, then we can transform the Uni-bit Trie shown in Fig.1(b) into a Multi-bit Trie as shown in Fig.1(c). During the transforming process, some prefixes must be expanded. Such as 11(P2), since the first stride is 3, it should be expanded to 110(P2) and 111(P2). But 110(P5) is already exist in the FIB, so we only store the longer one 110(P5).
  Multi-bit Trie can obviously reduce the tree level, but the problem is how to build a Multi-bit Trie with the minimal memory consumption (the number of memory units). As shown in Fig.1, the Uni-bit Trie has 23 nodes and consumes 46 memory units in total, while the Multi-bit Trie has 12 nodes and consumes 38 memory units in total.
 

Input
  The first line is an integer T, which is the number of testing cases.
  The first line of each case contains one integer L, which means the number of levels in the Uni-bit Trie.
  Following L lines indicate the nodes in each level of the Uni-bit Trie.
  Since only 64 bits of an IPv6 address is used for forwarding, a Uni-bit Trie has maximal 64 levels. Moreover, we suppose that the stride for each level of a Multi-bit Trie must be less than or equal to 20.
 

Output
  Output the minimal possible memory units consumed by the corresponding Multi-bit Trie.
 

Sample Input
  
  
1 7 1 2 4 4 5 4 3
 

Sample Output
  
  
38
 

Source
 

Recommend
zhoujiaqi2010
 

题目意思:

题目难的不是算法难的是英语呀。。。。TT。。

转化题意,就是给n个数,求一个划分使得各段
num[i]*2^len之和最小。num[i]为该段的第一个数。len为该段的长度。
每一段的个数不超过20。(开始没读出来。wa了千百回)
思路:
dp[i]表示i个数时满足题目要求的划分的最小总和。

dp[i]=Min(dp[i],dp[i-j]+num[i-j+1]*2^j);

#include <iostream>
#include<stdio.h>
#include<string.h>
using namespace std;
typedef __int64 ll;
ll dp[70],num[70];
ll MIN(ll a,ll b){ return a<b?a:b; }
int n;
int main()
{
    int cas,i,j;

    scanf("%d",&cas);
    while(cas--)
    {
        scanf("%d",&n);
        for(i=1; i<=n; i++)
            scanf("%I64d",&num[i]);
        memset(dp,0x3f,sizeof dp);//初始化为无穷大
        dp[0]=0;
        for(i=1; i<=n; i++)
        {
            //dp[i]=num[1]*(1LL<<i);会溢出
            for(j=1; j<=i&&j<=20; j++)//枚举最后一个区间的长度
                dp[i]=MIN(dp[i],dp[i-j]+num[i-j+1]*(1LL<<j));
        }
        printf("%I64d\n",dp[n]);
    }
    return 0;
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值